COMMENT #
=============================================================================
	dbcsstub
=============================================================================
#

_TEXT		SEGMENT
		ASSUME	cs:_TEXT, ds:_TEXT

	ORG	0

		dd	-1
		dw	8000h
		dw	Strategy
off_commands	dw	InitCommands
		db	'$DBCSSTB'

org_int21	dd	?

Strategy	PROC	FAR
	mov	word ptr cs:[req_hdr],bx
	mov	word ptr cs:[req_hdr + 2],es
	ret
Strategy	ENDP

Commands	PROC	FAR
	push	bx
	push	ds
	lds	bx,cs:[req_hdr]
	mov	word ptr [bx + 3],8103h
	pop	ds
	pop	bx
	ret
Commands	ENDP

New21		PROC	FAR
	pushf
	cmp	ax,6300h
	je	new21_dbcs
	popf
	jmp	cs:[org_int21]
new21_dbcs:
	push	cs
	pop	ds
	mov	si,offset dbcs_count + 2
	popf
	clc
	ret	2
New21		ENDP

req_hdr		dd	?
dbcs_count	dw	6
		db	81h,9fh
		db	0e0h,0fch
		db	0,0
		db	0,0


DevBottom	LABEL	NEAR
;----------------------------------------------------------------------------

Pmsg		PROC	NEAR
	push	ax
	mov	ah,9
	int	21h
	pop	ax
	ret
Pmsg		ENDP

InitCommands	PROC	FAR
	push	ax
	push	bx
	push	dx
	push	si
	push	ds
	push	es
	
	mov	ax,6300h
	int	21h
	jc	initcm_err
	cmp	al,0ffh
	je	initcm_err
	push	cs
	pop	ds
	les	bx,[req_hdr]
	mov	dx,offset msgOpening
	call	Pmsg
	mov	ax,3521h
	int	21h
	mov	word ptr [org_int21],bx
	mov	word ptr [org_int21 + 2],es
	mov	dx,offset New21
	mov	ax,2521h
	int	21h
	mov	dx,offset msgInstalled
	call	Pmsg
	lds	bx,[req_hdr]
	mov	word ptr [bx+13],1
	mov	word ptr [bx+14],offset DevBottom
	mov	word ptr [bx+16],cs
	mov	word ptr [bx+3],0100h
	mov	cs:[off_commands],offset Commands
	jmp	short initcm_exit
initcm_err:
	lds	bx,[req_hdr]
	mov	word ptr [bx+13],1
	mov	word ptr [bx+14],0
	mov	word ptr [bx+16],cs
	mov	word ptr [bx+3],8103h

initcm_exit:
	pop	es
	pop	ds
	pop	si
	pop	dx
	pop	bx
	pop	ax
	ret
InitCommands	ENDP



msgOpening	db	'DBCSSTUB.SYS $'
msgInstalled	db	'installed.',13,10,'$'

_TEXT		ENDS

	END
